package dev.shadowsoffire.apotheosis.mixin;

import net.minecraft.world.entity.Mob;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import net.minecraft.util.RandomSource;
import net.minecraft.core.BlockPos;
import net.minecraft.world.entity.MobSpawnType;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.entity.EntityType;
import org.spongepowered.asm.mixin.injection.callback.LocalCapture;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import net.minecraft.network.chat.Component;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.monster.Slime;
import org.spongepowered.asm.mixin.Mixin;

@Mixin({ Slime.class })
public class SlimeMixin
{
    @Inject(at = { @At(value = "INVOKE", target = "net/minecraft/world/level/Level.addFreshEntity(Lnet/minecraft/world/entity/Entity;)Z") }, method = { "remove(Lnet/minecraft/world/entity/Entity$RemovalReason;)V" }, locals = LocalCapture.CAPTURE_FAILHARD, require = 1)
    public void apoth_markMovable(final Entity.RemovalReason reason, final CallbackInfo ci, final int size, final Component name, final boolean noAI, final float f, final int j, final int k, final int l, final float f1, final float f2, final Slime slime) {
        if (noAI) {
            final boolean isMoveable = ((Slime)this).getPersistentData().m_128471_("apotheosis:movable");
            if (isMoveable) {
                slime.getPersistentData().m_128379_("apotheosis:movable", true);
            }
        }
    }
    
    @Inject(at = { @At("HEAD") }, method = { "checkSlimeSpawnRules" }, cancellable = true)
    private static void apoth_allowSlimesFromSpawner(final EntityType<Slime> pSlime, final LevelAccessor pLevel, final MobSpawnType pSpawnType, final BlockPos pPos, final RandomSource pRandom, final CallbackInfoReturnable<Boolean> cir) {
        if (pSpawnType == MobSpawnType.SPAWNER) {
            cir.setReturnValue((Object)Mob.m_217057_((EntityType)pSlime, pLevel, pSpawnType, pPos, pRandom));
        }
    }
}
